use std::fmt::Write;
use dim_sdk::{plugin_info, Context, DimPlugin};
use chrono::{NaiveDate, Local};

plugin_info!(
    Plug,                    // Your main global structs name that implements `DimPlugin`
    "counter",               // Plugin name
    "1.0.0",                 // Plugin Version (leave empty for none)
    "GPLv3"                  // Plugin license (leave empty for none)
    );

#[derive(Debug, Clone)]
struct Plug {
}

impl Plug {
    pub fn new() -> Self {
        Self {

        }
    }
}

impl DimPlugin for Plug {
    fn init(&mut self, _ctx: Context) {}
    fn poll(&mut self, f: &mut dim_sdk::CBuffer) -> dim_sdk::Result<()> {

        let start_date = NaiveDate::from_ymd_opt(2024, 3, 8).expect("Invalid date");
        let current_date = Local::now().date_naive();
        let duration = current_date.signed_duration_since(start_date);

        write!(f, "{} days <3", duration.num_days())?;
        Ok(())
    }
    fn pre_reload(&mut self) {}
    fn post_reload(&mut self) {}
    fn free(&mut self) {}
}




